#include <stdio.h>
#include <math.h>

/* programa para escribir en un archivo la solucion analitica
de la ecuacion del pendulo ideal cuando se la puede resolver
en la aproximacion lineal (en cuyo caso es equivalente a la
ecuacion de un oscilador armonico de la forma l x'' + G x  =0).
Las condiciones iniciales son x(t=0) = x0 y v(t=0) = v0. 
Los parametros de la ecuacion son la longitud del pendulo, l, y la 
aceleracion de la gravedad, G, cuyo valor ya esta definido en el programa.
Tanto las condiciones iniciales como la longitud se ingresan
por pantalla. El archivo de salida se llama arm_pend.txt.
Tambien es necesario decir entre que instantes se quiere escribir
la solucion (t_min y t_max) y cuantos puntos se quiere considerar
entre esos instantes (n_t).
*/


void main()
{
FILE *datfile;
double t,x,A,phi,x0,v0,l,G,omega;
double dt,t_min,t_max,one,pi;
int n_t,i;

G=9.81;
datfile = fopen("arm_pend.txt","w");

printf("longitud del pendulo \n");
printf(" l\n");
scanf("%lg",&l);
printf("Condiciones iniciales \n");
printf("x0, v0\n");
scanf("%lg %lg",&x0,&v0);
printf("Numero de puntos, n_t \n");
scanf("%ld",&n_t);
printf("t_min,t_max \n");
scanf("%lg %lg",&t_min,&t_max);

/* Calculo de pi*/

one=1.0;
pi=4.*atan(one);

/* Calculo de la pulsacion*/

omega = sqrt(G/l);

/* Calculo del "paso" temporal */

dt=(t_max-t_min)/n_t;

/* Calculo de la amplitud de oscilacion y del desfasaje */

if ( x0 == 0)
  {
    phi=0.5*pi;
    A=-v0/omega;
  }
else
  {
    phi=-atan(v0/(x0*omega));
    A=x0/cos(phi);
  }

/* Escribir solucion analitica para los n_t + 1 tiempos elegidos en
el archivo arm_pend.txt */
  
for (i=0;i<= n_t; i++)
{
  t=t_min+i*dt;
  x=A*cos(omega*t+phi);
  fprintf(datfile,"%lg %lg \n",t,x);
}


exit(0);
}

