#include <stdio.h>
#include <math.h>

/* programa para escribir en un archivo la solucion analitica
de la ecuacion del oscilador armonico (mx''= -kx) con condiciones 
iniciales x(t=0) = x0 y v(t=0) = v0. Los parametros de la ecuacion 
son la masa de la particula, m, y la constante del resorte, k.
Tanto las condiciones iniciales como estos parametros se ingresan
por pantalla. El archivo de salida se llama armonico.txt.
Tambien es necesario decir entre que instantes se quiere escribir
la solucion (t_min y t_max) y cuantos puntos se quiere considerar
entre esos instantes (n_t).
*/


void main()
{
FILE *datfile;
double t,x,A,phi,x0,v0,m,k,omega;
double dt,t_min,t_max,one,pi;
int n_t,i;

datfile = fopen("armonico.txt","w");

printf("Masa y constante del resorte \n");
printf(" m, k\n");
scanf("%lg %lg",&m,&k);
printf("Condiciones iniciales \n");
printf("x0, v0\n");
scanf("%lg %lg",&x0,&v0);
printf("Numero de puntos, n_t \n");
scanf("%ld",&n_t);
printf("t_min,t_max \n");
scanf("%lg %lg",&t_min,&t_max);

/* Calculo de pi*/

one=1.0;
pi=4.*atan(one);

/* Calculo de la pulsacion*/

omega = sqrt(k/m);

/* Calculo del "paso" temporal */

dt=(t_max-t_min)/n_t;

/* Calculo de la amplitud de oscilacion y del desfasaje */

if ( x0 == 0)
  {
    phi=0.5*pi;
    A=-v0/omega;
  }
else
  {
    phi=-atan(v0/(x0*omega));
    A=x0/cos(phi);
  }

/* Escribir solucion analitica para los n_t + 1 tiempos elegidos en
el archivo armonico.txt */
  
for (i=0;i<= n_t; i++)
{
  t=t_min+i*dt;
  x=A*cos(omega*t+phi);
  fprintf(datfile,"%lg %lg \n",t,x);
}


exit(0);
}

